/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): 
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.web.catalina40;

import org.apache.catalina.LifecycleException;
import org.apache.catalina.core.StandardContext;

// import JOnAS
import org.objectweb.jonas.common.Log;

//import objectweb
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;

public final class JOnASStandardContext extends  StandardContext {
 
    
    /**
     * Logger for this service.
     */
    protected static Logger logger = null;

    /**
     * Instance of Catalina 
     */

    protected  EmbeddedCatalina embedded = null;

    JOnASStandardContext(){
	super();
	logger = Log.getLogger(Log.JONAS_WEB_PREFIX);
    }

    /*
     * set the Embededded Catalina
     */
    public void setEmbedded(EmbeddedCatalina ec) {
	embedded = ec;
	embedded.addContext(this);
    }

    public synchronized void start() throws LifecycleException {
	logger.log(BasicLevel.DEBUG," JOnASStandardContext start");
	if ( embedded.isStarted() ) {
	    super.start();
	    
	} 

    }
}
