/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Ludovic Bert, Florent BENOIT
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.web.catalina41;

//import jonas
import org.objectweb.jonas.common.Log;

//import monolog
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.BasicLevel;


/**
 * This class provides a JOnAS logger for Catalina.
 * JWebContainerService service.
 * 03/03 Extends LoggerBase instead of implements Logger.
 * @author Florent Benoit
 * @author Ludovic Bert
 */
public class JCatalinaLogger extends org.apache.catalina.logger.LoggerBase {

    /**
     * Reference on the logger of JOnAS.
     */
    private Logger logger = null;

    /**
     * The descriptive information about this implementation.
     */
    protected static final String info = "org.objectweb.jonas.web.catalina41.JCatalinaLogger/1.0";


    /**
     * Contruct a new JCatalinaLogger : JOnAS logger for Catalina.
     */
    public JCatalinaLogger() {
        logger = Log.getLogger(Log.JONAS_WEB_PREFIX);
    }

    /**
     * Writes the specified message to a servlet log file, usually an event
     * log.  The name and type of the servlet log is specific to the
     * servlet container.
     * @param msg A <code>String</code> specifying the message to be written to the log file
     */
    public void log(String msg) {
        logger.log(BasicLevel.DEBUG, msg);
    }

}
