/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Miroslav Halas based on Catalina service
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.web.jetty;

import javax.management.MBeanException;
import javax.management.InstanceNotFoundException;

import org.mortbay.jetty.Server;
import org.mortbay.jetty.jmx.ServerMBean;

/**
 * Define The MBean for Jetty
 * @author Miroslav Halas
 */
public class JettyJonasServerMBean extends ServerMBean {

    /**
     * Constructor.
     * @param jettyServer instance of Jetty server.
     * @throws MBeanException if Mbean fail.
     * @throws InstanceNotFoundException if it can found the instance.
     */
    public JettyJonasServerMBean(Server jettyServer) throws MBeanException, 
        InstanceNotFoundException {
        super(jettyServer);
    }
}
