/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------$
 * --------------------------------------------------------------------------
 */

/**
 * This is an entity bean with "container managed persistence version 1.x".
 * This bean is used to test an entity with auto generated primary key
 * @author Jerome Camilleri
 */
package org.objectweb.jonas.jtests.beans.ebasic;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import javax.ejb.CreateException;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBException;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.ejb.EJBObject;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;
import javax.transaction.NotSupportedException;
import javax.transaction.Status;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;
import org.objectweb.jonas.common.Log;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.BasicLevel;

/**
 *
 */
public  abstract class pkautoEC extends pkautoEC2 implements javax.ejb.EntityBean {


    // ------------------------------------------------------------------
    // State of the bean. 
    // 
    // ------------------------------------------------------------------
    public int field1;
    public int field2;
    public java.lang.Integer field3;
    public  int getField1(){
	return field1;
    }
    public  void setField1(int f1){
	field1 = f1;
    }

    public  int getField2(){
	return field2;
    }
    public  void setField2(int f2){
	field2 = f2;
    }

    public java .lang.Integer getField3(){
	return field3;
    }

    public  void setField3(java.lang.Integer f3){
	field3 = f3;
    }


    // ------------------------------------------------------------------
    // EntityBean implementation
    // ------------------------------------------------------------------

    public void setEntityContext(EntityContext ctx) {
        if (logger == null) {
            logger = Log.getLogger("org.objectweb.jonas_tests");
        }
        logger.log(BasicLevel.DEBUG, "");
        ejbContext = ctx;
    }

    public void unsetEntityContext() {
        logger.log(BasicLevel.DEBUG, "");
        ejbContext = null;
    }


    public void ejbRemove() throws RemoveException {
        logger.log(BasicLevel.DEBUG, "");
    }

    public void ejbLoad() {
        logger.log(BasicLevel.DEBUG, "");
    }

    public void ejbStore() {
        logger.log(BasicLevel.DEBUG, "");
    }


    public void ejbPassivate() {
        logger.log(BasicLevel.DEBUG, "");
    }


    public void ejbActivate() {
        logger.log(BasicLevel.DEBUG, "");
    }

    public void ejbPostCreate(int f1, int f2){
        logger.log(BasicLevel.DEBUG, "");
    }

    public java.lang.Integer ejbCreate(int f1, int f2) throws CreateException{
        logger.log(BasicLevel.DEBUG, "");


        // Init here the bean fields
        field1 = f1;
        field2 = f2;

        // In CMP, should return null.
        return null;
    }
    // ------------------------------------------------------------------
    // testPkAut implementation
    // ------------------------------------------------------------------

    /**
     * method1
     */
    public void method1() {
        logger.log(BasicLevel.DEBUG, "");
    }

    /**
     * method2
     */
    public void method2(java.lang.String s) {
        logger.log(BasicLevel.DEBUG, "");
    }

}



