package org.objectweb.jonas.jtests.beans.ejbql;

import javax.ejb.CreateException;
import javax.ejb.FinderException;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Set;

import org.objectweb.jonas.jtests.beans.ejbql.AddressRemote;

public interface CustomerHomeRemote extends javax.ejb.EJBHome {

    public CustomerRemote create(Integer id) throws CreateException, RemoteException;
    public CustomerRemote findByPrimaryKey(Integer id) throws FinderException, RemoteException;
    public CustomerRemote findByExactName(String lastName, String firstName) throws FinderException, RemoteException;
    public Collection findByName(String lastName, String firstName)
	throws FinderException, RemoteException;
    public Collection findAllMike()
	throws FinderException, RemoteException;
    public CustomerRemote findSmith90()  
	throws FinderException, RemoteException;
    public Collection findByGoodCredit()
	throws FinderException, RemoteException;
    public Collection findByCity(String city, String state)
	throws FinderException, RemoteException;
    public Collection findInHotStates()
	throws FinderException, RemoteException;
    public Collection findWithNoReservations()
	throws FinderException, RemoteException;
    public Collection findByNameAndState(String lastName, String firstName, String state)
	throws FinderException, RemoteException;
    public Collection findAllCreditCardAddress(String city)
        throws FinderException, RemoteException;
    public Collection findAllCustomersWithReservation()
        throws FinderException, RemoteException;
    public Collection findAllCustomersWithReservationDistinct()
        throws FinderException, RemoteException;
    public Collection findByAddress(AddressRemote add) throws FinderException, RemoteException;
    public Collection findCustomersAll() 
        throws FinderException, RemoteException;


    // Home method, requires ejbHomeXXX method in bean class
    public Collection callFindOnCruise(Integer cruiseId)
    	throws FinderException, RemoteException;
    public Collection callFindByAddressLocal(Integer add)
        throws FinderException, RemoteException;
    public String selectAddrCity(Integer id) throws javax.ejb.FinderException, RemoteException;
    public String selectLastName(Integer id) throws javax.ejb.FinderException, RemoteException;
    public Set selectFirstName() throws javax.ejb.FinderException, RemoteException;
    public Integer selectAddr(Integer id) throws javax.ejb.FinderException, RemoteException;
    public Collection selectAllCreditCardAddr() throws javax.ejb.FinderException, RemoteException;
    public Collection selectRogerAddr() throws javax.ejb.FinderException, RemoteException;


}

