#!/usr/bin/perl -w

use CGI;

# ------------------------------------------
# constants
# ------------------------------------------
use constant SENDMAIL  => "/usr/sbin/sendmail -t";
use constant THANKS_PAGE  => "../../jonas/thanks.html";

# ------------------------------------------
# main program
# ------------------------------------------
$query = new CGI;
$query->cgi_error && error( $query, "An error has occured: " . $query->cgi_error . ".");

# check query
$name = $query->param('Name');
$email = $query->param('Email');
$organization = $query->param('Organization');
$to = $query->param('to');
&check_arguments();

# send result email
&send_mail();

# redirect to a thanks page
print $query->redirect(THANKS_PAGE);

exit 0;

# ------------------------------------------
# check query arguments
# ------------------------------------------
sub check_arguments() {

  # name
  if  ( !defined($name) || ($name eq "") ) {
    error( $query, 'The name is required.' );
  }

  # email
  if  ( !defined($email) ) {
    error( $query, 'The e-mail is required.' );
  } else {
    unless ( $email =~/^.+\@.+/ ) {
      if  ($email eq "") {
	error( $query, 'The e-mail is required.' );
      } else {
	error( $query, 'The e-mail format is invalid.' );	
      }
    }
  }

  # organization
  if  ( !defined($organization) || ($organization eq "") ) {
    error( $query, 'The organization is required.' );
  }

  # to field (result message)
  if  ( !defined($to) || ($to eq "") ) {
    error( $query, 'No email specified for result message.' );
  }
}

# ------------------------------------------
# send result mail
# ------------------------------------------
sub send_mail() {

  open(EMAIL,"| " . SENDMAIL);

  my $from_field = $name . " <" . $email . ">";

  print EMAIL "From: $from_field\n";
  print EMAIL "To: $to\n";
  print EMAIL "Reply-To: $from_field\n";
  print EMAIL "Errors-To: $from_field\n";
  print EMAIL "Sender: $from_field\n";
  print EMAIL "Subject: JOnAS questionnaire\n";
  print EMAIL "X-Real-Host-From: " . $ENV{'REMOTE_HOST'} ? $ENV{'REMOTE_HOST'} : $ENV{'REMOTE_ADDR'} . "\n\n";

  print EMAIL "=============================================================\n";
  print EMAIL "JOnAS Questionnaire\n";
  print EMAIL "=============================================================\n";

  print EMAIL "Name:         $name\n";
  print EMAIL "Email:        $email\n";
  print EMAIL "Organization: $organization\n";
  print EMAIL "Research:     " . $query->param('Research') . "\n\n";

  print EMAIL "Host:    $ENV{REMOTE_HOST}\n";
  print EMAIL "IP addr: $ENV{REMOTE_ADDR}\n";
  print EMAIL "User:    $ENV{REMOTE_USER}\n";
  print EMAIL "Server:  $ENV{SERVER_NAME}\n";
  print EMAIL "URL:     $ENV{REMOTE_URL}\n";
  print EMAIL "Browser: $ENV{HTTP_USER_AGENT}\n\n";

  print EMAIL "JOnAS version: ";
  $other = $query->param('Other version');
  if ( $other ) {
    print EMAIL "$other";
  } else {
    print EMAIL $query->param('JOnAS');
  }
  print EMAIL "\n\n";

  print EMAIL "OS:\n";
  &write($query->param('Windows'));
  &write($query->param('Linux'));
  &write($query->param('Solaris'));
  &write($query->param('AIX'));
  &write($query->param('HP-UX'));

  $other = $query->param('Other OS');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "JVM:\n";
  &write($query->param('JDK1.2'));
  &write($query->param('JDK1.3'));
  &write($query->param('JDK1.4'));
  $other = $query->param('Other JVM');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Databases:\n";
  &write($query->param('Access'));
  &write($query->param('DB 2'));
  &write($query->param('Informix'));
  &write($query->param('InstantDB'));
  &write($query->param('Interbase'));
  &write($query->param('Objectstore'));
  &write($query->param('Oracle'));
  &write($query->param('Postgres'));
  &write($query->param('SQL server'));
  &write($query->param('Versant'));
  $other = $query->param('Other database');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Applications:\n";
  &write($query->param('App1'));
  &write($query->param('App2'));
  &write($query->param('App3'));
  &write($query->param('App4'));
  &write($query->param('App5'));
  &write($query->param('App6'));
  &write($query->param('App7'));
  &write($query->param('App8'));
  &write($query->param('App9'));
  &write($query->param('App10'));
  &write($query->param('App11'));
  &write($query->param('App12'));
  &write($query->param('App13'));
  &write($query->param('App14'));
  &write($query->param('App15'));
  &write($query->param('App16'));
  $other = $query->param('Other application');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "Status: " . $query->param('Status') . "\n\n";

  print EMAIL "Benefits:\n";
  &write($query->param('Ben1'));
  &write($query->param('Ben2'));
  &write($query->param('Ben3'));
  &write($query->param('Ben4'));
  &write($query->param('Ben5'));
  &write($query->param('Ben6'));
  &write($query->param('Ben7'));
  &write($query->param('Ben8'));
  &write($query->param('Ben9'));
  &write($query->param('Ben10'));
  $other = $query->param('Other benefit');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Problems:\n";
  &write($query->param('Pb1'));
  &write($query->param('Pb2'));
  &write($query->param('Pb3'));
  &write($query->param('Pb4'));
  &write($query->param('Pb5'));
  &write($query->param('Pb6'));
  &write($query->param('Pb7'));
  &write($query->param('Pb8'));
  &write($query->param('Pb9'));
  &write($query->param('Pb10'));
  &write($query->param('Pb11'));
  &write($query->param('Pb12'));
  &write($query->param('Pb13'));
  &write($query->param('Pb14'));
  &write($query->param('Pb15'));
  &write($query->param('Pb16'));
  &write($query->param('Pb17'));
  &write($query->param('Pb18'));
  &write($query->param('Pb19'));
  &write($query->param('Pb20'));
  &write($query->param('Pb21'));
  $other = $query->param('Other problem');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Other EJB server: ";
  if ( $query->param('Other EJB servers') eq "Yes" ) {
    print EMAIL $query->param('Which other EJB');
  } else {
    print EMAIL "no";
  }
  print EMAIL "\n\n";

  print EMAIL "Enhancements:\n";
  &write($query->param('Enh1'));
  &write($query->param('Enh2'));
  &write($query->param('Enh3'));
  &write($query->param('Enh4'));
  &write($query->param('Enh5'));
  &write($query->param('Enh6'));
  &write($query->param('Enh7'));
  &write($query->param('Enh8'));
  &write($query->param('Enh9'));
  &write($query->param('Enh10'));
  &write($query->param('Enh11'));
  &write($query->param('Enh12'));
  &write($query->param('Enh13'));
  &write($query->param('Enh14'));
  &write($query->param('Enh15'));
  $other = $query->param('Other enhancement');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Comments:\n";
  print EMAIL $query->param('Other comments') . "\n";

  print EMAIL "=============================================================\n\n";

  close (EMAIL);
}

# ------------------------------------------
# print error message
# ------------------------------------------
sub error {
    my( $q, $reason ) = @_;

    print $q->header( "text/html" );
    print $q->start_html(-title=>'JOnAS questionnaire - Error');
    print $q->h1('JOnAS questionnaire - Error</strong>');
    print "<p>Your request has not been proceed because the following error has occured:<br>";
    print "<font color=\'red\'>";
    print $q->i( $reason );
    print "</font>";

    # footer
    print $q->hr;
    print "<address><a href=\"mailto:webmaster\@objectweb.org\">webmaster\@objectweb.org</a></address>";
    print $q->end_html;

    exit 1;
}

# ------------------------------------------
# write argument to email
# ------------------------------------------
sub write {
    my( $arg ) = @_;

    if ( $arg ) {
      print EMAIL $arg . "\n";
    }
}
