#!/usr/bin/perl -w

use CGI;

# ------------------------------------------
# constants
# ------------------------------------------
use constant SENDMAIL  => "/usr/sbin/sendmail -t";
use constant THANKS_PAGE  => "../../jonas/thanks.html";

# ------------------------------------------
# main program
# ------------------------------------------
$query = new CGI;
$query->cgi_error && error( $query, "An error has occured: " . $query->cgi_error . ".");

# check query
$name = $query->param('Name');
$email = $query->param('Email');
$organization = $query->param('Organization');
$website= $query->param('WebSite');
$to = $query->param('to');
&check_arguments();

# send result email
&send_mail();

# redirect to a thanks page
print $query->redirect(THANKS_PAGE);

exit 0;

# ------------------------------------------
# check query arguments
# ------------------------------------------
sub check_arguments() {

  # name
  if  ( !defined($name) || ($name eq "") ) {
    error( $query, 'The name is required.' );
  }

  # email
  if  ( !defined($email) ) {
    error( $query, 'The e-mail is required.' );
  } else {
    unless ( $email =~/^.+\@.+/ ) {
      if  ($email eq "") {
	error( $query, 'The e-mail is required.' );
      } else {
	error( $query, 'The e-mail format is invalid.' );	
      }
    }
  }

  # organization
  if  ( (!defined($organization) || ($organization eq ""))&
        (!defined($website) || ($website eq ""))
       ) {
    error( $query, 'The company name or web site is required.' );
  }

  # to field (result message)
  if  ( !defined($to) || ($to eq "") ) {
    error( $query, 'No email specified for result message.' );
  }
}

# ------------------------------------------
# send result mail
# ------------------------------------------
sub send_mail() {

  open(EMAIL,"| " . SENDMAIL);

  my $from_field = $name . " <" . $email . ">";

  print EMAIL "From: $from_field\n";
  print EMAIL "To: $to\n";
  print EMAIL "Reply-To: $from_field\n";
  print EMAIL "Errors-To: $from_field\n";
  print EMAIL "Sender: $from_field\n";
  print EMAIL "Subject: JOnAS questionnaire\n";
  print EMAIL "X-Real-Host-From: " . $ENV{'REMOTE_HOST'} ? $ENV{'REMOTE_HOST'} : $ENV{'REMOTE_ADDR'} . "\n\n";

  print EMAIL "=============================================================\n";
  print EMAIL "JOnAS Questionnaire\n";
  print EMAIL "=============================================================\n";

  print EMAIL "Name:         $name\n";
  print EMAIL "Email:        $email\n";
  print EMAIL "WebSite: " .  $query->param('WebSite') . "\n\n";
  print EMAIL "Country: " .  $query->param('Country') . "\n\n";
  print EMAIL "Organization: $organization\n";
  
  print EMAIL "Host:    $ENV{REMOTE_HOST}\n";
  print EMAIL "IP addr: $ENV{REMOTE_ADDR}\n";
  print EMAIL "User:    $ENV{REMOTE_USER}\n";
  print EMAIL "Server:  $ENV{SERVER_NAME}\n";
  print EMAIL "URL:     $ENV{REMOTE_URL}\n";
  print EMAIL "Browser: $ENV{HTTP_USER_AGENT}\n\n";

  print EMAIL "Marketing: " . $query->param('Marketing') . "\n\n";

  print EMAIL "Status: " . $query->param('Status') . "\n\n";
  print EMAIL "NumberUsers: " . $query->param('NumberUsers') . "\n\n";
  print EMAIL "SiteURL: " . $query->param('SiteURL') . "\n\n";

  print EMAIL "Top3Req1: " . $query->param('Top3Req1') . "\n\n";
  print EMAIL "Top3Req2: " . $query->param('Top3Req2') . "\n\n";
  print EMAIL "Top3Req3: " . $query->param('Top3Req3') . "\n\n";
  
  print EMAIL "Top3Diff1: " . $query->param('Top3Diff1') . "\n\n";
  print EMAIL "Top3Diff2: " . $query->param('Top3Diff2') . "\n\n";
  print EMAIL "Top3Diff3: " . $query->param('Top3Diff3') . "\n\n";

  print EMAIL "JOnAS version: ";
  $other = $query->param('Other version');
  if ( $other ) {
    print EMAIL "$other";
  } else {
    print EMAIL $query->param('JOnAS');
  }
  print EMAIL "\n\n";

  print EMAIL "OS:\n";
  &write($query->param('Windows'));
  &write($query->param('Linux'));
  &write($query->param('Solaris'));
  &write($query->param('AIX'));
  &write($query->param('HP-UX'));

  $other = $query->param('Other OS');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "IDE:\n";
  &write($query->param('JBuilder'));
  &write($query->param('Eclipse'));
  &write($query->param('NetBeans'));
  $other = $query->param('Other JVM');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Databases:\n";
  &write($query->param('Access'));
  &write($query->param('DB 2'));
  &write($query->param('Informix'));
  &write($query->param('InstantDB'));
  &write($query->param('Interbase'));
  &write($query->param('Objectstore'));
  &write($query->param('Oracle'));
  &write($query->param('Postgres'));
  &write($query->param('SQL server'));
  &write($query->param('Versant'));
  $other = $query->param('Other database');
  if ( $other ) {
    print EMAIL " Other: $other\n";
  }
  print EMAIL "\n";

  print EMAIL "Patterns:\n";
  &write($query->param('TC'));
  &write($query->param('JC'));
  &write($query->param('OC'));
  &write($query->param('SSB'));
  &write($query->param('SLB'));
  &write($query->param('BMP'));
  &write($query->param('CMP'));
  &write($query->param('CMPL'));
  &write($query->param('MDB'));
  &write($query->param('RMI'));
  &write($query->param('JRMI'));
  &write($query->param('JRMICR'));
  &write($query->param('DAVID'));
  &write($query->param('TOMCAT'));
  &write($query->param('JETTY'));
  &write($query->param('JCA'));
 


  print EMAIL "Comments:\n";
  print EMAIL $query->param('Comments') . "\n\n";
  print EMAIL "AcceptCommercialInfo: " . $query->param('AcceptCommercialInfo') . "\n\n";

  print EMAIL "=============================================================\n\n";

  close (EMAIL);
}

# ------------------------------------------
# print error message
# ------------------------------------------
sub error {
    my( $q, $reason ) = @_;

    print $q->header( "text/html" );
    print $q->start_html(-title=>'JOnAS questionnaire - Error');
    print $q->h1('JOnAS questionnaire - Error</strong>');
    print "<p>Your request has not been proceed because the following error has occured:<br>";
    print "<font color=\'red\'>";
    print $q->i( $reason );
    print "</font>";

    # footer
    print $q->hr;
    print "<address><a href=\"mailto:webmaster\@objectweb.org\">webmaster\@objectweb.org</a></address>";
    print $q->end_html;

    exit 1;
}

# ------------------------------------------
# write argument to email
# ------------------------------------------
sub write {
    my( $arg ) = @_;

    if ( $arg ) {
      print EMAIL $arg . "\n";
    }
}
